
***************************************
Instructions for random number generation for facility lists:

	-Enter the filepath, including file name, for the facility list.
	-Do not use any apostrophes or quotations in the file path.
	-Be sure the facility list file type is a .csv and that this is 
	 included in the path's file name below.
	-Review variable names on your list to ensure they match with this 
	 program. The following fields (not case-sensitive) are used to 
	 generate a random number for each facility:
		-orgID
		-locCDC
		-locationType
		-ccn;
****************************************;


*Enter file path here;
%let facilitypath = C:\folder\foler\Facility List_CLABSI.csv;


*Do not edit anything below this point.;
proc import out = facilitylist
	datafile = "&facilitypath"
	dbms = csv
	replace;
	guessingrows= 200;
run;

data facilitylist2;
set facilitylist;
where orgid ne . and locCDC = "" and locationType = "";
keep orgID ccn;
run;

proc sql noprint;
    select count(*) into :fn
    from facilitylist2;
quit;

data facilitylist3;
set facilitylist2;
 do i = 1 to &fn;
        randnum = rand("integer",0,100000);
	end; drop i;
run;

proc sort data=facilitylist3 out=FinalFacilityList; by randnum; run;

data _null_;
call symput("fname", scan("&facilitypath",-1,"\"));
run;
data _null_;
call symput("fOut", tranwrd("&facilitypath","&fname", "Facility List with RandNum.xlsx"));
run;

proc export data=finalfacilitylist 
outfile= "&fOut" 
dbms=xlsx replace;
run;

*"FinalFacilityList" if the final facility list with a random number 
 assigned and sorted.

 This dataset has been exported to the same path as the original facility 
 list and named "Facility List with RandNum.xlsx";